;File: 				BlitzEvent_Collisions.bb
;Author: 			Silver_Knee
;Description: 		Erweiterung um Blitz3D-Collisions als BlitzEvent verarbeiten zu knnen.
;Original Uploaded: www.BlitzForum.de

;--{BlitzEvents Extension for Collisions v1}--

Global BLITZEVENT_COLLISION=AddBlitzEventKind()

;---{Public Types}---

;Collision : Speichert informationene ber die Kollision als BLITZEVENT_COLLISION-BlitzEventInfo.

Type Collision
	Field Entity
	Field nx#,ny#,nz#
	Field Surface,Time,Triangle
	Field x#,y#,z#
End Type

;---{Public Functions}---

;WatchEntityCollisions(ent%,firekind=0,fireinfo=0)	: Entity fr das checken vormerken. Man kann ihm ein Event bertragen, dass es bei Kollision aktiviert.
;UnWatchEntityCollisions(ent%)						: Entity  nicht mehr fr das checken vormerken.
;CheckCollisions()									: berprft das Entity auf Kollisionen. Aktiviert alle Events.

Function WatchEntityCollisions(ent%,firekind=0,fireinfo=0)
	Local we.WatchedEntity,bee.BlitzEventError
	
	For we=Each WatchedEntity
		If we\ent=ent Then Exit
	Next
	
	If we<>Null
		bee=New BlitzEventError
		bee\txt="WatchEntityCollisions: Entity '"+EntityName(ent)+"'["+ent+"] is already watched."
		bee\errorid=BLITZEVENT_ERROR_OTHER
		FireBlitzEvent(BLITZEVENT_ERROR,Handle(bee))
	Else
		we=New WatchedEntity
		we\ent=ent
		we\firekind=firekind
		we\fireinfo=fireinfo
	EndIf
	
End Function

Function UnWatchEntityCollisions(ent%)
	Local we.WatchedEntity,bee.BlitzEventError
	
	For we=Each WatchedEntity
		If we\ent=ent Then Exit
	Next
	
	If we=Null
		bee=New BlitzEventError
		bee\txt="UnWatchEntityCollisions: Entity '"+EntityName(ent)+"'["+ent+"] was not watched."
		bee\errorid=BLITZEVENT_ERROR_OTHER
		FireBlitzEvent(BLITZEVENT_ERROR,Handle(bee))
	Else
		Delete we
	EndIf
	
End Function

Function CheckCollisions()
	Local we.WatchedEntity,co.Collision,count,max
	
	For we=Each WatchedEntity
		max=CountCollisions(we\ent)
		For count=1 To max
			co=New Collision
			co\Entity=	CollisionEntity(we\ent,count)
			co\nx=		CollisionNX(we\ent,count)
			co\ny=		CollisionNY(we\ent,count)
			co\nz=		CollisionNZ(we\ent,count)
			co\x=		CollisionX(we\ent,count)
			co\y=		CollisionY(we\ent,count)
			co\z=		CollisionZ(we\ent,count)
			co\Surface=	CollisionSurface(we\ent,count)
			co\Time=	CollisionTime(we\ent,count)
			co\Triangle=CollisionTriangle(we\ent,count)
			
			FireBlitzEvent(BLITZEVENT_COLLISION,Handle(co))
			FireBlitzEvent(we\firekind,we\fireinfo)
		Next
	Next
End Function

;---{Internal Types}---

Type WatchedEntity
	Field ent,firekind,fireinfo
End Type
;~IDEal Editor Parameters:
;~C#Blitz3D