;File: 				Collisions_Sample2.bb
;Author: 			Silver_Knee
;Description: 		Demonstriert die Funktionsweise der BlitzEvent_Collisions mit den eingebauten Events
;Original Uploaded: www.BlitzForum.de

Include "BlitzEvent_Basic.bb"
Include "BlitzEvent_Collisions.bb"

Graphics3D 800,600,32,2
SetBuffer BackBuffer()

Global Movement3D,END_PROGRAM

LAMPON=AddBlitzEventKind()
Movement3D=AddBlitzEventKind()
END_PROGRAM=AddBlitzEventKind()

Type Movement3D_Type
	Field x#,z#
End Type

Local Sphere,lamp,cam,light,mov.Movement3D_Type,co.Collision,resetsurface,resettriangle

light=CreateLight()

Sphere=CreateSphere()
EntityType Sphere,1

WatchEntityCollisions Sphere; Bei Kollision wird LAMPON ausgelst

lamp=CreateCylinder()
PositionEntity lamp,0,0,6
EntityType lamp,1
EntityFX lamp,2

cam=CreateCamera()

PositionEntity cam,0,5,-5
TurnEntity cam,20,0,0

Collisions 1,1,2,2

Repeat
	;Eingabe
	If KeyDown(200) Or KeyDown(17);hoch
		mov=New Movement3D_Type
		mov\x=0
		mov\z=+0.1
		FireBlitzEvent(Movement3D,Handle(mov))
	EndIf
	
	If KeyDown(203) Or KeyDown(30);links
		mov=New Movement3D_Type
		mov\x=-0.1
		mov\z=0
		FireBlitzEvent(Movement3D,Handle(mov))
	EndIf
	
	If KeyDown(205) Or KeyDown(32);rechts
		mov=New Movement3D_Type
		mov\x=+0.1
		mov\z=0
		FireBlitzEvent(Movement3D,Handle(mov))
	EndIf
	
	If KeyDown(208) Or KeyDown(31);runter
		mov=New Movement3D_Type
		mov\x=0
		mov\z=-0.1
		FireBlitzEvent(Movement3D,Handle(mov))	
	EndIf
	
	If KeyDown(1)
		FireBlitzEvent(END_PROGRAM,0)
	EndIf
	
	CheckCollisions()
	
	;Verarbeitung
	If resetsurface<>0
		VertexColor resetsurface,TriangleVertex(resetsurface,resettriangle,0),255,255,255
		VertexColor resetsurface,TriangleVertex(resetsurface,resettriangle,1),255,255,255
		VertexColor resetsurface,TriangleVertex(resetsurface,resettriangle,2),255,255,255
	EndIf
	
	While NextBlitzEvent()
		Select BlitzEventKind
			Case Movement3D
				mov=Object.Movement3D_Type(BlitzEventInfo)
				MoveEntity Sphere,mov\x,0,mov\z
				Delete mov
			Case BLITZEVENT_COLLISION
				co=Object.Collision(BlitzEventInfo)
				
				VertexColor co\Surface,TriangleVertex(co\Surface,co\Triangle,0),0,0,255
				VertexColor co\Surface,TriangleVertex(co\Surface,co\Triangle,1),0,0,255
				VertexColor co\Surface,TriangleVertex(co\Surface,co\Triangle,2),0,0,255
				
				resetsurface=co\Surface
				resettriangle=co\Triangle
				
				Delete co
			Case BLITZEVENT_ERROR
				Delete Object.BlitzEventError(BlitzEventInfo);Die Errors verfallen
			Case END_PROGRAM
				End		
		End Select
	Wend;Vor diesem Wend mssen alle Objekte, die als Handle in einer BlitzEventInfo liegen, gelscht werden.
	
	;Ausgabe
	UpdateWorld
	RenderWorld
	Flip 
	Cls
Forever
;~IDEal Editor Parameters:
;~C#Blitz3D